=== modified file 'database/schema/security.cfg'
--- database/schema/security.cfg	2012-01-05 21:38:46 +0000
+++ database/schema/security.cfg	2012-01-05 15:19:43 +0000
@@ -2157,7 +2157,7 @@
 public.revisionauthor                   = SELECT, UPDATE
 public.revisioncache                    = SELECT, DELETE
 public.sourcepackagename                = SELECT
-public.sourcepackagerelease             = SELECT, UPDATE
+public.sourcepackagerelease             = SELECT
 public.sourcepackagepublishinghistory   = SELECT, UPDATE
 public.suggestivepotemplate             = INSERT, DELETE
 public.teamparticipation                = SELECT, DELETE

=== modified file 'lib/lp/answers/browser/faq.py'
--- lib/lp/answers/browser/faq.py	2012-01-05 20:11:40 +0000
+++ lib/lp/answers/browser/faq.py	2012-01-05 19:49:38 +0000
@@ -1,4 +1,4 @@
-# Copyright 2009-2012 Canonical Ltd.  This software is licensed under the
+# Copyright 2009 Canonical Ltd.  This software is licensed under the
 # GNU Affero General Public License version 3 (see the file LICENSE).
 
 """`IFAQ` browser views."""

=== modified file 'lib/lp/app/doc/launchpadform.txt'
--- lib/lp/app/doc/launchpadform.txt	2012-01-05 19:57:47 +0000
+++ lib/lp/app/doc/launchpadform.txt	2012-01-05 19:53:05 +0000
@@ -528,7 +528,7 @@
 However, there are cases where a form action is safe (e.g. a "search"
 action).  Those actions can be marked as such:
 
-  >>> from lp.app.browser.launchpadform import safe_action
+  >>> from lp.services.webapp import safe_action
   >>> class UnsafeActionTestView(LaunchpadFormView):
   ...     schema = IFormTest
   ...     field_names = ['name']
@@ -588,7 +588,7 @@
 
 In other respects, it is used the same way as LaunchpadFormView:
 
-  >>> from lp.app.browser.launchpadform import LaunchpadEditFormView
+  >>> from lp.services.webapp import LaunchpadEditFormView
   >>> class FormTestView8(LaunchpadEditFormView):
   ...     schema = IFormTest
   ...     field_names = ['displayname']

=== modified file 'lib/lp/archiveuploader/nascentupload.py'
--- lib/lp/archiveuploader/nascentupload.py	2012-01-05 11:48:27 +0000
+++ lib/lp/archiveuploader/nascentupload.py	2011-12-24 13:09:35 +0000
@@ -1,4 +1,4 @@
-# Copyright 2009-2012 Canonical Ltd.  This software is licensed under the
+# Copyright 2009-2011 Canonical Ltd.  This software is licensed under the
 # GNU Affero General Public License version 3 (see the file LICENSE).
 
 """The processing of nascent uploads.
@@ -909,10 +909,10 @@
             # state.
             pass
 
-        with open(self.changes.filepath, "r") as changes_file_object:
-            self.queue_root.notify(
-                summary_text=self.rejection_message,
-                changes_file_object=changes_file_object, logger=self.logger)
+        changes_file_object = open(self.changes.filepath, "r")
+        self.queue_root.notify(summary_text=self.rejection_message,
+            changes_file_object=changes_file_object, logger=self.logger)
+        changes_file_object.close()
 
     def _createQueueEntry(self):
         """Return a PackageUpload object."""

=== removed file 'lib/lp/archiveuploader/tests/test_sync_notification.py'
--- lib/lp/archiveuploader/tests/test_sync_notification.py	2012-01-06 06:07:34 +0000
+++ lib/lp/archiveuploader/tests/test_sync_notification.py	1970-01-01 00:00:00 +0000
@@ -1,178 +0,0 @@
-# Copyright 2012 Canonical Ltd.  This software is licensed under the
-# GNU Affero General Public License version 3 (see the file LICENSE).
-
-"""Test notification behaviour for cross-distro package syncs."""
-
-__metaclass__ = type
-
-import os.path
-
-from zope.component import getUtility
-
-from lp.archiveuploader.nascentupload import (
-    NascentUpload,
-    UploadError,
-    )
-from lp.registry.interfaces.pocket import PackagePublishingPocket
-from lp.services.log.logger import DevNullLogger
-from lp.soyuz.enums import (
-    ArchivePermissionType,
-    SourcePackageFormat,
-    )
-from lp.soyuz.interfaces.sourcepackageformat import (
-    ISourcePackageFormatSelectionSet,
-    )
-from lp.soyuz.model.archivepermission import ArchivePermission
-from lp.soyuz.scripts.packagecopier import do_copy
-from lp.testing import (
-    login,
-    TestCaseWithFactory,
-    )
-from lp.testing.fakemethod import FakeMethod
-from lp.testing.layers import LaunchpadZopelessLayer
-from lp.testing.mail_helpers import pop_notifications
-
-
-class FakeUploadPolicy:
-    def __init__(self, spph):
-        self.distroseries = spph.distroseries
-        self.archive = spph.distroseries.main_archive
-        self.pocket = spph.pocket
-
-    setDistroSeriesAndPocket = FakeMethod()
-    validateUploadType = FakeMethod()
-    checkUpload = FakeMethod()
-
-
-class FakeChangesFile:
-    def __init__(self, spph, file_path):
-        self.files = []
-        self.filepath = file_path
-        self.filename = os.path.basename(file_path)
-        self.architectures = ['i386']
-        self.suite_name = '-'.join([spph.distroseries.name, spph.pocket.name])
-        self.raw_content = open(file_path).read()
-        self.signingkey = None
-
-    checkFileName = FakeMethod([])
-    processAddresses = FakeMethod([])
-    processFiles = FakeMethod([])
-    verify = FakeMethod([UploadError("Deliberately broken")])
-
-
-class TestSyncNotification(TestCaseWithFactory):
-
-    layer = LaunchpadZopelessLayer
-
-    def makePersonWithEmail(self):
-        """Create a person; return (person, email)."""
-        address = "%s@example.com" % self.factory.getUniqueString()
-        person = self.factory.makePerson(email=address)
-        return person, address
-
-    def makeSPPH(self, distroseries, maintainer_address):
-        """Create a `SourcePackagePublishingHistory`."""
-        return self.factory.makeSourcePackagePublishingHistory(
-            distroseries=distroseries, pocket=PackagePublishingPocket.RELEASE,
-            dsc_maintainer_rfc822=maintainer_address)
-
-    def makeUploader(self, person, archive, component):
-        """Grant a person upload privileges for archive/component."""
-        ArchivePermission(
-            person=person, archive=archive, component=component,
-            permission=ArchivePermissionType.UPLOAD)
-
-    def syncSource(self, spph, target_distroseries, requester):
-        """Sync `spph` into `target_distroseries`."""
-        getUtility(ISourcePackageFormatSelectionSet).add(
-            target_distroseries, SourcePackageFormat.FORMAT_1_0)
-        target_archive = target_distroseries.main_archive
-        self.makeUploader(requester, target_archive, spph.component)
-        [synced_spph] = do_copy(
-            [spph], target_archive, target_distroseries,
-            pocket=spph.pocket, person=requester, allow_delayed_copies=False,
-            close_bugs=False)
-        return synced_spph
-
-    def makeChangesFile(self, spph, maintainer, maintainer_address,
-                        changer, changer_address):
-        temp_dir = self.makeTemporaryDirectory()
-        changes_file = os.path.join(
-            temp_dir, "%s.changes" % spph.source_package_name)
-        with open(changes_file, 'w') as changes:
-            changes.write(
-                "Maintainer: %s <%s>\n"
-                "Changed-By: %s <%s>\n"
-                % (
-                    maintainer.name,
-                    maintainer_address,
-                    changer.name,
-                    changer_address,
-                    ))
-        return FakeChangesFile(spph, changes_file)
-
-    def makeNascentUpload(self, spph, maintainer, maintainer_address,
-                          changer, changer_address):
-        """Create a `NascentUpload` for `spph`."""
-        changes = self.makeChangesFile(
-            spph, maintainer, maintainer_address, changer, changer_address)
-        upload = NascentUpload(
-            changes, FakeUploadPolicy(spph), DevNullLogger())
-        upload.queue_root = upload._createQueueEntry()
-        das = self.factory.makeDistroArchSeries(
-            distroseries=spph.distroseries)
-        bpb = self.factory.makeBinaryPackageBuild(
-            source_package_release=spph.sourcepackagerelease,
-            archive=spph.archive, distroarchseries=das, pocket=spph.pocket,
-            sourcepackagename=spph.sourcepackagename)
-        upload.queue_root.addBuild(bpb)
-        return upload
-
-    def processAndRejectUpload(self, nascent_upload):
-        nascent_upload.process()
-        # Obtain the required privileges for do_reject.
-        login('foo.bar@canonical.com')
-        nascent_upload.do_reject(notify=True)
-
-    def getNotifiedAddresses(self):
-        """Get email addresses that were notified."""
-        return [message['to'] for message in pop_notifications()]
-
-    def test_failed_copy_builds_do_not_spam_upstream(self):
-        """Failed builds do not spam people who are not responsible for them.
-
-        We import Debian source packages, then sync them into Ubuntu (and
-        from there, into Ubuntu-derived distros).  Those syncs then trigger
-        builds that the original Debian maintainers and last-change authors
-        are not responsible for.
-
-        In a situation like that, we should not bother those people with the
-        failure.  We notify the person who requested the sync instead.
-
-        (The logic in lp.soyuz.adapters.notification may still notify the
-        author of the last change, if that person is also an uploader for the
-        archive that the failure happened in.  For this particular situation
-        we consider that not so much an intended behaviour, as an emergent one
-        that does not seem inappropriate.  It'd be hard to change if we wanted
-        to.)
-
-        This test guards against bug 876594.
-        """
-        maintainer, maintainer_address = self.makePersonWithEmail()
-        changer, changer_address = self.makePersonWithEmail()
-        dsp = self.factory.makeDistroSeriesParent()
-        original_spph = self.makeSPPH(dsp.parent_series, maintainer_address)
-        sync_requester, syncer_address = self.makePersonWithEmail()
-        synced_spph = self.syncSource(
-            original_spph, dsp.derived_series, sync_requester)
-        nascent_upload = self.makeNascentUpload(
-            synced_spph, maintainer, maintainer_address,
-            changer, changer_address)
-        pop_notifications()
-        self.processAndRejectUpload(nascent_upload)
-
-        notified_addresses = '\n'.join(self.getNotifiedAddresses())
-
-        self.assertNotIn(maintainer_address, notified_addresses)
-        self.assertNotIn(changer_address, notified_addresses)
-        self.assertIn(syncer_address, notified_addresses)

=== modified file 'lib/lp/bugs/browser/bugattachment.py'
--- lib/lp/bugs/browser/bugattachment.py	2012-01-05 20:11:40 +0000
+++ lib/lp/bugs/browser/bugattachment.py	2012-01-05 19:53:05 +0000
@@ -1,4 +1,4 @@
-# Copyright 2010-2012 Canonical Ltd.  This software is licensed under the
+# Copyright 2010-2011 Canonical Ltd.  This software is licensed under the
 # GNU Affero General Public License version 3 (see the file LICENSE).
 
 """Bug attachment views."""

=== modified file 'lib/lp/bugs/browser/bugsubscription.py'
--- lib/lp/bugs/browser/bugsubscription.py	2012-01-05 20:11:40 +0000
+++ lib/lp/bugs/browser/bugsubscription.py	2012-01-05 19:23:25 +0000
@@ -1,4 +1,4 @@
-# Copyright 2009-2012 Canonical Ltd.  This software is licensed under the
+# Copyright 2009-2011 Canonical Ltd.  This software is licensed under the
 # GNU Affero General Public License version 3 (see the file LICENSE).
 
 """Views for BugSubscription."""

=== modified file 'lib/lp/bugs/browser/bugsupervisor.py'
--- lib/lp/bugs/browser/bugsupervisor.py	2012-01-05 20:11:40 +0000
+++ lib/lp/bugs/browser/bugsupervisor.py	2012-01-05 19:23:25 +0000
@@ -1,4 +1,4 @@
-# Copyright 2009-2012 Canonical Ltd.  This software is licensed under the
+# Copyright 2009-2010 Canonical Ltd.  This software is licensed under the
 # GNU Affero General Public License version 3 (see the file LICENSE).
 
 """Browser view for bug supervisor."""

=== modified file 'lib/lp/registry/browser/__init__.py'
--- lib/lp/registry/browser/__init__.py	2012-01-05 20:11:40 +0000
+++ lib/lp/registry/browser/__init__.py	2012-01-05 19:23:25 +0000
@@ -1,4 +1,4 @@
-# Copyright 2009-2012 Canonical Ltd.  This software is licensed under the
+# Copyright 2009 Canonical Ltd.  This software is licensed under the
 # GNU Affero General Public License version 3 (see the file LICENSE).
 
 """Common registry browser helpers and mixins."""

=== modified file 'lib/lp/registry/browser/branding.py'
--- lib/lp/registry/browser/branding.py	2012-01-05 20:11:40 +0000
+++ lib/lp/registry/browser/branding.py	2012-01-05 19:49:38 +0000
@@ -1,4 +1,4 @@
-# Copyright 2009-2012 Canonical Ltd.  This software is licensed under the
+# Copyright 2009-2011 Canonical Ltd.  This software is licensed under the
 # GNU Affero General Public License version 3 (see the file LICENSE).
 
 """Browser views for items that can be displayed as images."""

=== modified file 'lib/lp/registry/browser/distributionsourcepackage.py'
--- lib/lp/registry/browser/distributionsourcepackage.py	2012-01-05 20:11:40 +0000
+++ lib/lp/registry/browser/distributionsourcepackage.py	2012-01-05 19:49:38 +0000
@@ -1,4 +1,4 @@
-# Copyright 2009-2012 Canonical Ltd.  This software is licensed under the
+# Copyright 2009-2010 Canonical Ltd.  This software is licensed under the
 # GNU Affero General Public License version 3 (see the file LICENSE).
 
 __metaclass__ = type

=== modified file 'lib/lp/registry/browser/distroseries.py'
--- lib/lp/registry/browser/distroseries.py	2012-01-05 20:11:40 +0000
+++ lib/lp/registry/browser/distroseries.py	2012-01-05 19:49:38 +0000
@@ -1,4 +1,4 @@
-# Copyright 2009-2012 Canonical Ltd.  This software is licensed under the
+# Copyright 2009-2011 Canonical Ltd.  This software is licensed under the
 # GNU Affero General Public License version 3 (see the file LICENSE).
 
 """View classes related to `IDistroSeries`."""

=== modified file 'lib/lp/registry/browser/distroseriesdifference.py'
--- lib/lp/registry/browser/distroseriesdifference.py	2012-01-05 20:11:40 +0000
+++ lib/lp/registry/browser/distroseriesdifference.py	2012-01-05 19:23:25 +0000
@@ -1,4 +1,4 @@
-# Copyright 2010-2012 Canonical Ltd.  This software is licensed under the
+# Copyright 2010-2011 Canonical Ltd.  This software is licensed under the
 # GNU Affero General Public License version 3 (see the file LICENSE).
 
 """Browser views for DistroSeriesDifferences."""

=== modified file 'lib/lp/registry/browser/driver.py'
--- lib/lp/registry/browser/driver.py	2012-01-05 20:11:40 +0000
+++ lib/lp/registry/browser/driver.py	2012-01-05 19:49:38 +0000
@@ -1,4 +1,4 @@
-# Copyright 2009-2012 Canonical Ltd.  This software is licensed under the
+# Copyright 2009 Canonical Ltd.  This software is licensed under the
 # GNU Affero General Public License version 3 (see the file LICENSE).
 
 """Browser view class for drivers."""

=== modified file 'lib/lp/registry/browser/karma.py'
--- lib/lp/registry/browser/karma.py	2012-01-05 20:11:40 +0000
+++ lib/lp/registry/browser/karma.py	2012-01-05 19:49:38 +0000
@@ -1,4 +1,4 @@
-# Copyright 2009-2012 Canonical Ltd.  This software is licensed under the
+# Copyright 2009 Canonical Ltd.  This software is licensed under the
 # GNU Affero General Public License version 3 (see the file LICENSE).
 
 __metaclass__ = type

=== modified file 'lib/lp/registry/browser/nameblacklist.py'
--- lib/lp/registry/browser/nameblacklist.py	2012-01-05 20:11:40 +0000
+++ lib/lp/registry/browser/nameblacklist.py	2012-01-05 19:49:38 +0000
@@ -1,4 +1,4 @@
-# Copyright 2010-2012 Canonical Ltd.  This software is licensed under the
+# Copyright 2010 Canonical Ltd.  This software is licensed under the
 # GNU Affero General Public License version 3 (see the file LICENSE).
 
 __metaclass__ = type

=== modified file 'lib/lp/scripts/garbo.py'
--- lib/lp/scripts/garbo.py	2012-01-06 12:11:50 +0000
+++ lib/lp/scripts/garbo.py	2012-01-04 11:49:08 +0000
@@ -86,7 +86,6 @@
     MAIN_STORE,
     MASTER_FLAVOR,
     )
-from lp.soyuz.model.sourcepackagerelease import SourcePackageRelease
 from lp.translations.interfaces.potemplate import IPOTemplateSet
 from lp.translations.model.potmsgset import POTMsgSet
 from lp.translations.model.potranslation import POTranslation
@@ -902,42 +901,6 @@
         self._update_oldest()
 
 
-class SourcePackageReleaseDscBinariesUpdater(TunableLoop):
-    """Fix incorrect values for SourcePackageRelease.dsc_binaries."""
-
-    maximum_chunk_size = 1000
-
-    def __init__(self, log, abort_time=None):
-        super(SourcePackageReleaseDscBinariesUpdater, self).__init__(
-            log, abort_time)
-        self.store = IMasterStore(SourcePackageRelease)
-        self.ids = list(
-            self.store.find(
-                SourcePackageRelease.id,
-                # Get all SPR IDs which have an incorrectly-separated
-                # dsc_binaries value (space rather than comma-space).
-                SQL("dsc_binaries ~ '[a-z0-9+.-] '"),
-                # Skip rows with dsc_binaries in dependency relationship
-                # format.  This is a different bug.
-                SQL("dsc_binaries NOT LIKE '%(%'")))
-
-    def isDone(self):
-        """See `TunableLoop`."""
-        return len(self.ids) == 0
-
-    def __call__(self, chunk_size):
-        """See `TunableLoop`."""
-        chunk_size = int(chunk_size + 0.5)
-        chunk_ids = self.ids[:chunk_size]
-        del self.ids[:chunk_size]
-        self.store.execute("""
-            UPDATE SourcePackageRelease
-            SET dsc_binaries = regexp_replace(
-                dsc_binaries, '([a-z0-9+.-]) ', E'\\\\1, ', 'g')
-            WHERE id IN %s""" % sqlvalues(chunk_ids), noresult=True)
-        transaction.commit()
-
-
 class SuggestiveTemplatesCacheUpdater(TunableLoop):
     """Refresh the SuggestivePOTemplate cache.
 
@@ -1302,7 +1265,6 @@
         ObsoleteBugAttachmentPruner,
         OldTimeLimitedTokenDeleter,
         RevisionAuthorEmailLinker,
-        SourcePackageReleaseDscBinariesUpdater,
         SuggestiveTemplatesCacheUpdater,
         POTranslationPruner,
         UnusedPOTMsgSetPruner,

=== modified file 'lib/lp/scripts/tests/test_garbo.py'
--- lib/lp/scripts/tests/test_garbo.py	2012-01-05 21:38:46 +0000
+++ lib/lp/scripts/tests/test_garbo.py	2012-01-04 11:49:08 +0000
@@ -996,42 +996,6 @@
         self.runDaily()
         self.assertEqual(0, unreferenced_msgsets.count())
 
-    def test_SourcePackageReleaseDscBinariesUpdater_updates_incorrect(self):
-        # SourcePackageReleaseDscBinariesUpdater fixes incorrectly-separated
-        # dsc_binaries values.
-        LaunchpadZopelessLayer.switchDbUser('testadmin')
-        spr = self.factory.makeSourcePackageRelease(
-            dsc_binaries="one two three")
-        transaction.commit()
-        self.runDaily()
-        self.assertEqual("one, two, three", spr.dsc_binaries)
-
-    def test_SourcePackageReleaseDscBinariesUpdater_skips_correct(self):
-        # SourcePackageReleaseDscBinariesUpdater leaves correct dsc_binaries
-        # values alone.
-        LaunchpadZopelessLayer.switchDbUser('testadmin')
-        spr_one = self.factory.makeSourcePackageRelease(dsc_binaries="one")
-        spr_three = self.factory.makeSourcePackageRelease(
-            dsc_binaries="one, two, three")
-        transaction.commit()
-        self.runDaily()
-        self.assertEqual("one", spr_one.dsc_binaries)
-        self.assertEqual("one, two, three", spr_three.dsc_binaries)
-
-    def test_SourcePackageReleaseDscBinariesUpdater_skips_broken(self):
-        # There have been a few instances of Binary fields in PPA packages
-        # that are formatted like a dependency relationship field, complete
-        # with (>= ...).  This is completely invalid (and failed to build),
-        # but does exist historically, so we have to deal with it.
-        # SourcePackageReleaseDscBinariesUpdater leaves such fields well
-        # alone.
-        LaunchpadZopelessLayer.switchDbUser('testadmin')
-        spr = self.factory.makeSourcePackageRelease(
-            dsc_binaries="one (>= 1), two")
-        transaction.commit()
-        self.runDaily()
-        self.assertEqual("one (>= 1), two", spr.dsc_binaries)
-
 
 class TestGarboTasks(TestCaseWithFactory):
     layer = LaunchpadZopelessLayer

=== modified file 'lib/lp/services/looptuner.py'
--- lib/lp/services/looptuner.py	2012-01-06 11:50:43 +0000
+++ lib/lp/services/looptuner.py	2012-01-01 02:58:52 +0000
@@ -49,9 +49,6 @@
         The chunk_size parameter says (in some way you define) how much work
         the LoopTuner believes you should try to do in this iteration in order
         to get as close as possible to your time goal.
-
-        Note that chunk_size is a float, so, for example, if you use it to
-        slice a list, be careful to round it to an int first.
         """
 
     def cleanUp(self):

=== modified file 'lib/lp/services/webapp/__init__.py'
--- lib/lp/services/webapp/__init__.py	2012-01-05 20:11:08 +0000
+++ lib/lp/services/webapp/__init__.py	2012-01-05 19:53:05 +0000
@@ -1,4 +1,4 @@
-# Copyright 2009-2012 Canonical Ltd.  This software is licensed under the
+# Copyright 2009 Canonical Ltd.  This software is licensed under the
 # GNU Affero General Public License version 3 (see the file LICENSE).
 
 """The webapp package contains infrastructure that is common across Launchpad
@@ -17,6 +17,8 @@
     'expand_numbers',
     'FacetMenu',
     'GetitemNavigation',
+    'LaunchpadEditFormView',
+    'LaunchpadFormView',
     'LaunchpadView',
     'LaunchpadXMLRPCView',
     'Link',
@@ -24,6 +26,7 @@
     'NavigationMenu',
     'nearest',
     'redirection',
+    'safe_action',
     'sorted_dotted_numbers',
     'sorted_version_numbers',
     'StandardLaunchpadFacets',
@@ -36,6 +39,11 @@
     'Utf8PreferredCharsets',
     ]
 
+from lp.app.browser.launchpadform import (
+    LaunchpadEditFormView,
+    LaunchpadFormView,
+    safe_action,
+    )
 from lp.services.webapp.menu import (
     ApplicationMenu,
     ContextMenu,

=== renamed file 'lib/lp/app/browser/tests/test_launchpadform_doc.py' => 'lib/lp/services/webapp/tests/test_launchpadform.py'
--- lib/lp/app/browser/tests/test_launchpadform_doc.py	2012-01-06 01:29:22 +0000
+++ lib/lp/services/webapp/tests/test_launchpadform.py	2012-01-01 02:58:52 +0000
@@ -95,7 +95,7 @@
 
         >>> from zope.app.form.interfaces import IDisplayWidget, IInputWidget
         >>> from zope.interface import directlyProvides, implements
-        >>> from lp.app.browser.launchpadform import (
+        >>> from lp.services.webapp import (
         ...     LaunchpadFormView, custom_widget)
         >>> from zope.schema import Bool
         >>> from zope.publisher.browser import TestRequest

=== modified file 'lib/lp/soyuz/browser/distroarchseries.py'
--- lib/lp/soyuz/browser/distroarchseries.py	2012-01-05 20:11:40 +0000
+++ lib/lp/soyuz/browser/distroarchseries.py	2012-01-01 02:58:52 +0000
@@ -1,4 +1,4 @@
-# Copyright 2009-2012 Canonical Ltd.  This software is licensed under the
+# Copyright 2009 Canonical Ltd.  This software is licensed under the
 # GNU Affero General Public License version 3 (see the file LICENSE).
 
 __metaclass__ = type
@@ -22,10 +22,12 @@
 from lp import _
 from lp.app.browser.launchpadform import (
     action,
+    LaunchpadFormView,
+    )
+from lp.services.webapp import (
+    GetitemNavigation,
     LaunchpadEditFormView,
-    LaunchpadFormView,
     )
-from lp.services.webapp import GetitemNavigation
 from lp.services.webapp.breadcrumb import Breadcrumb
 from lp.services.webapp.menu import (
     enabled_with_permission,

=== modified file 'lib/lp/soyuz/doc/gina.txt'
--- lib/lp/soyuz/doc/gina.txt	2012-01-05 13:03:31 +0000
+++ lib/lp/soyuz/doc/gina.txt	2011-12-30 06:14:56 +0000
@@ -280,8 +280,6 @@
     -----END PGP SIGNATURE-----
     >>> print cap.maintainer.displayname
     Michael Vogt
-    >>> print cap.dsc_binaries
-    libcap-dev, libcap-bin, libcap1
 
 Test ubuntu-meta in breezy, which was forcefully imported.
 

=== modified file 'lib/lp/soyuz/model/archive.py'
--- lib/lp/soyuz/model/archive.py	2012-01-05 08:51:58 +0000
+++ lib/lp/soyuz/model/archive.py	2011-12-30 06:14:56 +0000
@@ -1288,14 +1288,18 @@
             #   - the given source package directly
             #   - a package set in the correct distro series that includes the
             #     given source package
-            source_allowed = self.checkArchivePermission(
-                person, sourcepackagename)
+            source_allowed = self.checkArchivePermission(person,
+                                                         sourcepackagename)
             set_allowed = self.isSourceUploadAllowed(
                 sourcepackagename, person, distroseries)
             if source_allowed or set_allowed:
                 return None
 
         if not self.getComponentsForUploader(person):
+            # XXX: JamesWestby 2010-08-01 bug=612351: We have to use
+            # is_empty() as we don't get an SQLObjectResultSet back, and
+            # so __nonzero__ isn't defined on it, and a straight bool
+            # check wouldn't do the right thing.
             if self.getPackagesetsForUploader(person).is_empty():
                 return NoRightsForArchive()
             else:

=== modified file 'lib/lp/soyuz/model/queue.py'
--- lib/lp/soyuz/model/queue.py	2012-01-05 14:05:10 +0000
+++ lib/lp/soyuz/model/queue.py	2011-12-30 06:14:56 +0000
@@ -845,27 +845,6 @@
         # and uploading to any archive as the signer.
         return changes, strip_pgp_signature(changes_content).splitlines(True)
 
-    def findSourcePublication(self):
-        """Find the `SourcePackagePublishingHistory` for this build."""
-        first_build = self.builds[:1]
-        if first_build:
-            [first_build] = first_build
-            return first_build.build._getLatestPublication()
-        else:
-            return None
-
-    def findPersonToNotify(self):
-        """Find the right person to notify about this upload."""
-        spph = self.findSourcePublication()
-        if spph and self.sourcepackagerelease.upload_archive != self.archive:
-            # This is a build triggered by the syncing of a source
-            # package.  Notify the person who requested the sync.
-            return spph.creator
-        elif self.signing_key:
-            return self.signing_key.owner
-        else:
-            return None
-
     def notify(self, summary_text=None, changes_file_object=None,
                logger=None, dry_run=False):
         """See `IPackageUpload`."""
@@ -881,9 +860,12 @@
             changesfile_content = changes_file_object.read()
         else:
             changesfile_content = 'No changes file content available.'
-        blamee = self.findPersonToNotify()
+        if self.signing_key is not None:
+            signer = self.signing_key.owner
+        else:
+            signer = None
         notify(
-            blamee, self.sourcepackagerelease, self.builds, self.customfiles,
+            signer, self.sourcepackagerelease, self.builds, self.customfiles,
             self.archive, self.distroseries, self.pocket, summary_text,
             changes, changesfile_content, changes_file_object,
             status_action[self.status], dry_run=dry_run, logger=logger)

=== modified file 'lib/lp/soyuz/scripts/gina/handlers.py'
--- lib/lp/soyuz/scripts/gina/handlers.py	2012-01-05 14:23:33 +0000
+++ lib/lp/soyuz/scripts/gina/handlers.py	2011-12-30 06:14:56 +0000
@@ -1,4 +1,4 @@
-# Copyright 2009-2012 Canonical Ltd.  This software is licensed under the
+# Copyright 2009-2011 Canonical Ltd.  This software is licensed under the
 # GNU Affero General Public License version 3 (see the file LICENSE).
 
 """Gina db handlers.
@@ -654,7 +654,7 @@
             dsc_format=src.format,
             dsc_maintainer_rfc822=maintainer_line,
             dsc_standards_version=src.standards_version,
-            dsc_binaries=", ".join(src.binaries),
+            dsc_binaries=" ".join(src.binaries),
             upload_archive=distroseries.main_archive)
         log.info('Source Package Release %s (%s) created' %
                  (name.name, src.version))

=== modified file 'lib/lp/translations/browser/distribution.py'
--- lib/lp/translations/browser/distribution.py	2012-01-05 20:11:40 +0000
+++ lib/lp/translations/browser/distribution.py	2012-01-05 19:49:38 +0000
@@ -1,4 +1,4 @@
-# Copyright 2009-2012 Canonical Ltd.  This software is licensed under the
+# Copyright 2009-2011 Canonical Ltd.  This software is licensed under the
 # GNU Affero General Public License version 3 (see the file LICENSE).
 
 """Translations browser views for distributions."""

=== modified file 'lib/lp/translations/browser/distroseries.py'
--- lib/lp/translations/browser/distroseries.py	2012-01-05 20:11:40 +0000
+++ lib/lp/translations/browser/distroseries.py	2012-01-05 19:49:38 +0000
@@ -1,4 +1,4 @@
-# Copyright 2009-2012 Canonical Ltd.  This software is licensed under the
+# Copyright 2009 Canonical Ltd.  This software is licensed under the
 # GNU Affero General Public License version 3 (see the file LICENSE).
 
 """Translations view classes related to `IDistroSeries`."""

=== modified file 'lib/lp/translations/browser/potemplate.py'
--- lib/lp/translations/browser/potemplate.py	2012-01-05 20:11:40 +0000
+++ lib/lp/translations/browser/potemplate.py	2012-01-05 19:49:38 +0000
@@ -1,4 +1,4 @@
-# Copyright 2009-2012 Canonical Ltd.  This software is licensed under the
+# Copyright 2009-2010 Canonical Ltd.  This software is licensed under the
 # GNU Affero General Public License version 3 (see the file LICENSE).
 # pylint: disable-msg=F0401
 

=== modified file 'lib/lp/translations/browser/project.py'
--- lib/lp/translations/browser/project.py	2012-01-05 20:11:40 +0000
+++ lib/lp/translations/browser/project.py	2012-01-05 19:49:38 +0000
@@ -1,4 +1,4 @@
-# Copyright 2009-2012 Canonical Ltd.  This software is licensed under the
+# Copyright 2009 Canonical Ltd.  This software is licensed under the
 # GNU Affero General Public License version 3 (see the file LICENSE).
 
 """ProjectGroup-related View Classes"""

=== modified file 'versions.cfg'
--- versions.cfg	2012-01-06 15:27:56 +0000
+++ versions.cfg	2011-12-09 06:24:02 +0000
@@ -29,7 +29,7 @@
 iso8601 = 0.1.4
 Jinja2 = 2.2
 keyring = 0.6.2
-launchpadlib = 1.9.12
+launchpadlib = 1.9.11
 lazr.amqp = 0.1
 lazr.authentication = 0.1.1
 lazr.batchnavigator = 1.2.10

